// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_cli_toolbox/src/prompt/control.dart';
import 'package:wyatt_cli_toolbox/src/stylish/stylish.dart';

enum QuestionType {
  message,
  stringQuestion,
  booleanQuestion,
  listQuestion,
  passwordQuestion
}

abstract class Question<T> {
  Question(this.type, this.identifier, this.question, this.comment);

  final QuestionType type;
  final String identifier;
  final String question;
  final String? comment;

  String prefix = Control.questionIndicator();

  String formatComment() => (comment != null) ? ' $comment '.dim() : ' ';
  String formatQuestion() => '$prefix $question${formatComment()}';

  T ask();
}
